
// Filename: scwrap.h

//----------------------------------------------------------------------
//  Copyright (c) 2010 by Doulos.
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//----------------------------------------------------------------------

#ifndef SCWRAP_H
#define SCWRAP_H

#include "svdpi.h"
#include <vector>

#include "systemc"
using namespace sc_core;
using std::cout;
using std::endl;

#include "scmod.h"

extern "C"
void entry(int id, unsigned char cmd, int addr, int* data);

extern "C"
const char* get_path(int id);

class scwrap: public sc_module
{
public:
  scwrap(sc_module_name n);

  scmod* m_scmod;

  static std::vector<scwrap*> instance;
  static int count;
  int id;
};

#endif
